| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Classes | Public Member Functions | Static Public Member Functions | List of all members
Ogre::ResourceBackgroundQueue Class Reference
Core » Resources

This class is used to perform Resource operations in a background thread. More...

`#include <OgreResourceBackgroundQueue.h>`

Inheritance diagram for Ogre::ResourceBackgroundQueue:
[legend]

## Classes
class | Listener
| This abstract listener interface lets you get notifications of completed background processes instead of having to poll ticket statuses. More...

## Public Member Functions
| ResourceBackgroundQueue ()
virtual | ~ResourceBackgroundQueue ()
void | abortRequest (BackgroundProcessTicket ticket)
| Aborts background process. More...
bool | canHandleRequest (const WorkQueue::Request *req, const WorkQueue *srcQ)
| Implementation for WorkQueue::RequestHandler. More...
bool | canHandleResponse (const WorkQueue::Response *res, const WorkQueue *srcQ)
| Implementation for WorkQueue::ResponseHandler. More...
WorkQueue::Response * | handleRequest (const WorkQueue::Request *req, const WorkQueue *srcQ)
| Implementation for WorkQueue::RequestHandler. More...
void | handleResponse (const WorkQueue::Response *res, const WorkQueue *srcQ)
| Implementation for WorkQueue::ResponseHandler. More...
virtual void | initialise (void)
| Initialise the background queue system. More...
virtual BackgroundProcessTicket | initialiseAllResourceGroups (Listener *listener=0)
| Initialise all resource groups which are yet to be initialised in the background. More...
virtual BackgroundProcessTicket | initialiseResourceGroup (const String &name, Listener *listener=0)
| Initialise a resource group in the background. More...
virtual bool | isProcessComplete (BackgroundProcessTicket ticket)
| Returns whether a previously queued process has completed or not. More...
virtual BackgroundProcessTicket | load (const String &resType, const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, Listener *listener=0)
| Load a single resource in the background. More...
virtual BackgroundProcessTicket | loadResourceGroup (const String &name, Listener *listener=0)
| Loads a resource group in the background. More...
virtual BackgroundProcessTicket | prepare (const String &resType, const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, Listener *listener=0)
| Prepare a single resource in the background. More...
virtual BackgroundProcessTicket | prepareResourceGroup (const String &name, Listener *listener=0)
| Prepares a resource group in the background. More...
virtual void | shutdown (void)
| Shut down the background queue system. More...
virtual BackgroundProcessTicket | unload (const String &resType, const String &name, Listener *listener=0)
| Unload a single resource in the background. More...
virtual BackgroundProcessTicket | unload (const String &resType, ResourceHandle handle, Listener *listener=0)
| Unload a single resource in the background. More...
virtual BackgroundProcessTicket | unloadResourceGroup (const String &name, Listener *listener=0)
| Unloads a resource group in the background. More...

## Static Public Member Functions
static ResourceBackgroundQueue & | getSingleton (void)
| Get the singleton instance. More...
static ResourceBackgroundQueue * | getSingletonPtr (void)
| Get the singleton instance. More...

## Detailed Description

This class is used to perform Resource operations in a background thread.

Remarks
  All these requests are now queued via Root::getWorkQueue in order to share the thread pool amongst all background tasks. You should therefore refer to that class for configuring the behaviour of the threads themselves, this class merely provides an interface that is specific to resource loading around this common functionality.

  The general approach here is that on requesting a background resource process, your request is placed on a queue ready for the background thread to be picked up, and you will get a 'ticket' back, identifying the request. Your call will then return and your thread can proceed, knowing that at some point in the background the operation will be performed. In it's own thread, the resource operation will be performed, and once finished the ticket will be marked as complete. You can check the status of tickets by calling isProcessComplete() from your queueing thread.

## Constructor & Destructor Documentation

## ◆ ResourceBackgroundQueue()

Ogre::ResourceBackgroundQueue::ResourceBackgroundQueue | ( |  | ) |

## ◆ ~ResourceBackgroundQueue()

virtual Ogre::ResourceBackgroundQueue::~ResourceBackgroundQueue | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ initialise()

virtual void Ogre::ResourceBackgroundQueue::initialise | ( | void |  | ) |
| virtual

Initialise the background queue system.

Note
  Called automatically by Root::initialise.

## ◆ shutdown()

virtual void Ogre::ResourceBackgroundQueue::shutdown | ( | void |  | ) |
| virtual

Shut down the background queue system.

Note
  Called automatically by Root::shutdown.

## ◆ initialiseResourceGroup()

virtual BackgroundProcessTicket Ogre::ResourceBackgroundQueue::initialiseResourceGroup | ( | const String & | name,
|  | Listener * | listener = `0`
| ) |  |
| virtual

Initialise a resource group in the background.

See also
  ResourceGroupManager::initialiseResourceGroup

Parameters

  name | The name of the resource group to initialise
  listener | Optional callback interface, take note of warnings in the header and only use if you understand them.

Returns
  Ticket identifying the request, use isProcessComplete() to determine if completed if not using listener

## ◆ initialiseAllResourceGroups()

virtual BackgroundProcessTicket Ogre::ResourceBackgroundQueue::initialiseAllResourceGroups | ( | Listener * | listener = `0` | ) |
| virtual

Initialise all resource groups which are yet to be initialised in the background.

See also
  ResourceGroupManager::intialiseResourceGroup

Parameters

  listener | Optional callback interface, take note of warnings in the header and only use if you understand them.

Returns
  Ticket identifying the request, use isProcessComplete() to determine if completed if not using listener

## ◆ prepareResourceGroup()

virtual BackgroundProcessTicket Ogre::ResourceBackgroundQueue::prepareResourceGroup | ( | const String & | name,
|  | Listener * | listener = `0`
| ) |  |
| virtual

Prepares a resource group in the background.

See also
  ResourceGroupManager::prepareResourceGroup

Parameters

  name | The name of the resource group to prepare
  listener | Optional callback interface, take note of warnings in the header and only use if you understand them.

Returns
  Ticket identifying the request, use isProcessComplete() to determine if completed if not using listener

## ◆ loadResourceGroup()

virtual BackgroundProcessTicket Ogre::ResourceBackgroundQueue::loadResourceGroup | ( | const String & | name,
|  | Listener * | listener = `0`
| ) |  |
| virtual

Loads a resource group in the background.

See also
  ResourceGroupManager::loadResourceGroup

Parameters

  name | The name of the resource group to load
  listener | Optional callback interface, take note of warnings in the header and only use if you understand them.

Returns
  Ticket identifying the request, use isProcessComplete() to determine if completed if not using listener

## ◆ unload() [1/2]

virtual BackgroundProcessTicket Ogre::ResourceBackgroundQueue::unload | ( | const String & | resType,
|  | const String & | name,
|  | Listener * | listener = `0`
| ) |  |
| virtual

Unload a single resource in the background.

See also
  ResourceManager::unload

Parameters

  resType | The type of the resource (from ResourceManager::getResourceType())
  name | The name of the Resource
  listener | Optional callback interface, take note of warnings in the header and only use if you understand them.

## ◆ unload() [2/2]

virtual BackgroundProcessTicket Ogre::ResourceBackgroundQueue::unload | ( | const String & | resType,
|  | ResourceHandle | handle,
|  | Listener * | listener = `0`
| ) |  |
| virtual

Unload a single resource in the background.

See also
  ResourceManager::unload

Parameters

  resType | The type of the resource (from ResourceManager::getResourceType())
  handle | Handle to the resource
  listener | Optional callback interface, take note of warnings in the header and only use if you understand them.

## ◆ unloadResourceGroup()

virtual BackgroundProcessTicket Ogre::ResourceBackgroundQueue::unloadResourceGroup | ( | const String & | name,
|  | Listener * | listener = `0`
| ) |  |
| virtual

Unloads a resource group in the background.

See also
  ResourceGroupManager::unloadResourceGroup

Parameters

  name | The name of the resource group to load
  listener | Optional callback interface, take note of warnings in the header and only use if you understand them.

Returns
  Ticket identifying the request, use isProcessComplete() to determine if completed if not using listener

## ◆ prepare()

virtual BackgroundProcessTicket Ogre::ResourceBackgroundQueue::prepare | ( | const String & | resType,
|  | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | loadParams = `0`,
|  | Listener * | listener = `0`
| ) |  |
| virtual

Prepare a single resource in the background.

See also
  ResourceManager::prepare

Parameters

  resType | The type of the resource (from ResourceManager::getResourceType())
  name | The name of the Resource
  group | The resource group to which this resource will belong
  isManual | Is the resource to be manually loaded? If so, you should provide a value for the loader parameter
  loader | The manual loader which is to perform the required actions when this resource is loaded; only applicable when you specify true for the previous parameter. NOTE: must be thread safe!!
  loadParams | Optional pointer to a list of name/value pairs containing loading parameters for this type of resource. Remember that this must have a lifespan longer than the return of this call!
  listener | Optional callback interface, take note of warnings in the header and only use if you understand them.

## ◆ load()

virtual BackgroundProcessTicket Ogre::ResourceBackgroundQueue::load | ( | const String & | resType,
|  | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | loadParams = `0`,
|  | Listener * | listener = `0`
| ) |  |
| virtual

Load a single resource in the background.

See also
  ResourceManager::load

Parameters

  resType | The type of the resource (from ResourceManager::getResourceType())
  name | The name of the Resource
  group | The resource group to which this resource will belong
  isManual | Is the resource to be manually loaded? If so, you should provide a value for the loader parameter
  loader | The manual loader which is to perform the required actions when this resource is loaded; only applicable when you specify true for the previous parameter. NOTE: must be thread safe!!
  loadParams | Optional pointer to a list of name/value pairs containing loading parameters for this type of resource. Remember that this must have a lifespan longer than the return of this call!
  listener | Optional callback interface, take note of warnings in the header and only use if you understand them.

## ◆ isProcessComplete()

virtual bool Ogre::ResourceBackgroundQueue::isProcessComplete | ( | BackgroundProcessTicket | ticket | ) |
| virtual

Returns whether a previously queued process has completed or not.

Remarks
  This method of checking that a background process has completed is the 'polling' approach. Each queued method takes an optional listener parameter to allow you to register a callback instead, which is arguably more efficient.

Parameters

  ticket | The ticket which was returned when the process was queued

Returns
  true if process has completed (or if the ticket is unrecognised), false otherwise

Note
  Tickets are not stored once complete so do not accumulate over time. This is why a non-existent ticket will return 'true'.

## ◆ abortRequest()

void Ogre::ResourceBackgroundQueue::abortRequest | ( | BackgroundProcessTicket | ticket | ) |

Aborts background process.

## ◆ canHandleRequest()

bool Ogre::ResourceBackgroundQueue::canHandleRequest | ( | const WorkQueue::Request * | req,
|  | const WorkQueue * | srcQ
| ) |  |
| virtual

Implementation for WorkQueue::RequestHandler.

Reimplemented from Ogre::WorkQueue::RequestHandler.

## ◆ handleRequest()

WorkQueue::Response* Ogre::ResourceBackgroundQueue::handleRequest | ( | const WorkQueue::Request * | req,
|  | const WorkQueue * | srcQ
| ) |  |
| virtual

Implementation for WorkQueue::RequestHandler.

Implements Ogre::WorkQueue::RequestHandler.

## ◆ canHandleResponse()

bool Ogre::ResourceBackgroundQueue::canHandleResponse | ( | const WorkQueue::Response * | res,
|  | const WorkQueue * | srcQ
| ) |  |
| virtual

Implementation for WorkQueue::ResponseHandler.

Reimplemented from Ogre::WorkQueue::ResponseHandler.

## ◆ handleResponse()

void Ogre::ResourceBackgroundQueue::handleResponse | ( | const WorkQueue::Response * | res,
|  | const WorkQueue * | srcQ
| ) |  |
| virtual

Implementation for WorkQueue::ResponseHandler.

Implements Ogre::WorkQueue::ResponseHandler.

## ◆ getSingleton()

static ResourceBackgroundQueue& Ogre::ResourceBackgroundQueue::getSingleton | ( | void |  | ) |
| static

Get the singleton instance.

## ◆ getSingletonPtr()

static ResourceBackgroundQueue* Ogre::ResourceBackgroundQueue::getSingletonPtr | ( | void |  | ) |
| static

Get the singleton instance.

The documentation for this class was generated from the following file:

- OgreResourceBackgroundQueue.h